<?php
/**
*
* @package acp_prime_trash_bin_addons
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp_prime_trash_bin_addons
*/
class acp_prime_trash_bin_addons
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$user->add_lang('mods/prime_trash_bin_b');

		// Set up general vars
		$mode		= request_var('mode', 'topics');
		$start		= request_var('start', 0);
		$deletemark = (!empty($_POST['delmarked'])) ? true : false;
		$deleteall	= (!empty($_POST['delall'])) ? true : false;
		$marked		= request_var('mark', array(0));

		// Sort keys
		$sort_days	= request_var('st', 0);
		$sort_key	= 't';
		$sort_dir	= request_var('sd', 'd');

		$this->tpl_name = 'acp_prime_trash_bin_addons';

		// Delete entries if requested and able
		if (($deletemark || $deleteall))
		{
			if ((int)$user->data['user_type'] !== USER_FOUNDER)
			{
				trigger_error($user->lang['NO_AUTH_OPERATION'] . adm_back_link($this->u_action), E_USER_WARNING);
			}
			
			if (confirm_box(true))
			{
				if (!function_exists('delete_posts'))
				{
					include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
				}

				if ($deleteall)
				{
					switch ($mode)
					{
						case "topics":
							//Check deleted topics
							$sql = 'SELECT t.topic_id 
									FROM ' . TOPICS_TABLE . ' t
									WHERE t.topic_deleted_time > 0
										AND t.forum_id != ' . $config['trash_forum'];
							$result = $db->sql_query($sql);
							while ($row = $db->sql_fetchrow($result))
							{
								$marked[] = $row['topic_id'];
							}
							$db->sql_freeresult($result);
						break;

						case "posts":
							//Check deleted posts
							$sql = 'SELECT p.post_id 
									FROM ' . POSTS_TABLE . ' p
									WHERE p.post_deleted_time > 0
										AND p.forum_id != ' . $config['trash_forum'];
							$result = $db->sql_query($sql);
							while ($row = $db->sql_fetchrow($result))
							{
								$marked[] = $row['post_id'];
							}
							$db->sql_freeresult($result);
						break;
					}
				}
				
				if(sizeof($marked))
				{	
					if($mode == 'topics')
					{
						delete_topics('topic_id', $marked);
						add_log('admin', 'LOG_PURGE_DELETED_TOPICS');						
					}
					else if($mode == 'posts')
						{
							delete_posts('post_id', $marked);				
							add_log('admin', 'LOG_PURGE_DELETED_POSTS');
						}
				}
			}
			else
			{
				confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
					'start'		=> $start,
					'delmarked'	=> $deletemark,
					'delall'	=> $deleteall,
					'mark'		=> $marked,
					'st'		=> $sort_days,
					'sk'		=> $sort_key,
					'sd'		=> $sort_dir,
					'mode'		=> $mode))
				);
			}
		}

		// Sorting
		$limit_days = array(0 => $user->lang['ALL_ENTRIES'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);
		$sort_by_text = array('t' => $user->lang['SORT_DATE']);
		$sort_by_sql = array('t' => '_deleted_time');

		$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
		gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);

		// Define where and sort sql for use in displaying logs
		$sql_where = ($sort_days) ? (time() - ($sort_days * 86400)) : 0;
		$sql_sort = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

		$this->page_title = $user->lang['ACP_PRIME_TRASH_BIN_ADDONS'];

		switch ($mode)
		{
			case 'topics':
				$sql = 'SELECT t.topic_title subject, if(t.topic_moved_id = 0, t.topic_id, t.topic_moved_id) id, t.topic_deleted_from deleted_from, t.topic_deleted_user deleted_user, t.topic_deleted_time deleted_time, t.topic_deleted_reason deleted_reason, 
								u.username, u.username_clean, u.user_colour
						FROM ' . TOPICS_TABLE . ' t
						LEFT JOIN ' . USERS_TABLE . ' u ON (t.topic_deleted_user = u.user_id)
						WHERE t.topic_deleted_time > ' . $sql_where . '
							AND t.forum_id != ' . $config['trash_forum'] . '
						ORDER BY t.topic' . $sql_sort;
				$sql_count = 'SELECT count(t.topic_id) kol
						FROM ' . TOPICS_TABLE . ' t
						WHERE t.topic_deleted_time > ' . $sql_where . '
							AND t.forum_id != ' . $config['trash_forum'];		
			break;
			
			case 'posts':
				$sql = 'SELECT if(p.post_subject != "",p.post_subject,t.topic_title) subject, p.post_id id, p.post_deleted_from deleted_from, p.post_deleted_user deleted_user, p.post_deleted_time deleted_time, p.post_deleted_reason deleted_reason,
								u.username, u.username_clean, u.user_colour
						FROM ' . TOPICS_TABLE . ' t, ' . POSTS_TABLE . ' p 
						LEFT JOIN ' . USERS_TABLE . ' u ON (p.post_deleted_user = u.user_id)
						WHERE t.topic_id = p.topic_id
							AND p.post_deleted_time > ' . $sql_where . '
							AND p.forum_id != ' . $config['trash_forum'] . '
						ORDER BY p.post' . $sql_sort;
				$sql_count = 'SELECT count(p.post_id) kol
						FROM ' . TOPICS_TABLE . ' t, ' . POSTS_TABLE . ' p 
						WHERE t.topic_id = p.topic_id
							AND p.post_deleted_time > ' . $sql_where . '
							AND p.forum_id != ' . $config['trash_forum'];		
			break;
		}
		$result = $db->sql_query_limit($sql, $config['topics_per_page'], $start);
		
		$data_for_delete = array();
		
		while ($row = $db->sql_fetchrow($result))
		{
			$data_for_delete[] = $row;
		}
		$db->sql_freeresult($result);

		$result = $db->sql_query($sql_count);
		$count = (int)$db->sql_fetchfield('kol');
		$db->sql_freeresult($result);

		foreach ($data_for_delete as $row)
		{
			$template->assign_block_vars('data', array(
				'ID'				=> $row['id'],
				'USERNAME'			=> get_username_string('full', $row['deleted_user'], $row['username'], $row['user_colour'], false, append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=viewprofile')),
				'SUBJECT'			=> $row['subject'],
				'U_URL'				=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", (($mode == 'topics') ? 't=' . $row['id'] : 'p=' . $row['id'] . '#p' . $row['id'])),
				'DELETED_TIME'		=> $user->format_date($row['deleted_time']),
				'DELETED_REASON'	=> censor_text($row['deleted_reason']),
				)
			);
		}
		$template->assign_vars(array(
			'L_TITLE'		=> $user->lang['ACP_PRIME_TRASH_BIN_ADDONS_' . strtoupper($mode)],
			'L_EXPLAIN'		=> $user->lang['ACP_PRIME_TRASH_BIN_ADDONS_' . strtoupper($mode) .'_EXPLAIN'],
			'U_ACTION'		=> $this->u_action . "&amp;$u_sort_param&amp;start=$start",

			'S_ON_PAGE'		=> on_page($count, $config['topics_per_page'], $start),
			'PAGINATION'	=> generate_pagination($this->u_action . "&amp;$u_sort_param", $count, $config['topics_per_page'], $start),

			'S_LIMIT_DAYS'	=> $s_limit_days,
			'S_SORT_KEY'	=> $s_sort_key,
			'S_SORT_DIR'	=> $s_sort_dir,
			'S_PURGE'		=> ((int)$user->data['user_type'] === USER_FOUNDER) ? true : false,
			
			'MODE'		=> $mode,
			)
		);
		
	}
}

?>