<?php
/**
*
* @package phpBB3
* @version $Id: prime_trash_bin_addons.php, for v 1.1.6 Pazh Exp $
* @copyright (c) 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

//=======================================================================//
// Administration Functions                                              //
//=======================================================================//

function purge_deleted_topics_posts()
{
	global $db, $phpbb_root_path, $phpEx, $config;

	if (!function_exists('delete_posts'))
	{
		include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
	}
	
	$topics_for_delete = $posts_for_delete = array();

	//Check deleted topics
	$sql = 'SELECT t.topic_id 
			FROM ' . TOPICS_TABLE . ' t
			WHERE t.topic_deleted_time > 0
				AND t.forum_id != ' . $config['trash_forum'];
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		$topics_for_delete[] = $row['topic_id'];
	}
	$db->sql_freeresult($result);
	
	if(sizeof($topics_for_delete))
	{
		delete_topics('topic_id', $topics_for_delete);
	}
	
	//Check deleted posts
	$sql = 'SELECT p.post_id 
			FROM ' . POSTS_TABLE . ' p
			WHERE p.post_deleted_time > 0
				AND p.forum_id != ' . $config['trash_forum'];
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		$posts_for_delete[] = $row['post_id'];
	}
	$db->sql_freeresult($result);
	
	if(sizeof($posts_for_delete))
	{	
		delete_posts('post_id', $posts_for_delete);
	}
	
	unset($topics_for_delete, $posts_for_delete);
}
?>